/* Read a Vee file and write Vector info to a file RAM:Haha
Should even read compressed format files. 
note: not yet adapted for ieee files...
*/

arg fname
if fname = '' then exit(200)

Oserr = Open('FILE',fname,'R')
if oserr ~= 1 then exit(300)

/* it = open('LIST','RAM:Haha','W') */

/* we use routines to read the numbers in the Vpaint file */

/* validate header sexion */
header = Readch('FILE',4)
if Header ~= 'Vapr' then exit(400)

/* read compression info now! */
VersC= C2D(Readch('FILE',2))
/* and version info */
Vers = C2D(readch('FILE',2))
if Vers ~= 2 then exit(401)

header = Readch('FILE',4)
if Header ~= 'VapH' then exit(400)

NumMIDS = C2D(readch('FILE',4))+1
if numMIDS ~= 27 then exit(402)

Skip = readch('FILE',4*NumMids)

say ".Vee recognized: vers:" Vers " Compression:" VersC

/* initialize the useful constants */
KVT= 1 
KVC= 2 
KDS= 3 
KRV= 4 
KRf= 5 
KMV= 6 
KRM= 7 
KNT= 8 
KNV= 9 
KMI= 10 
KSX= 11 
KVW= 12 
KLK= 13 
KIN= 14 
KAR= 15 
KVZ= 16 
KAN= 17 
KNX= 18 
KAP= 19 
KSQ= 20 
KKF= 21 
KPX= 22 
KCL= 23 
KPN= 24 
KXX= 25 
KFI= 26 





do forever

LKI = Rint()
if EOF('FILE') = 1 then Leave

LK_P = Rint()
LK_C = Rint()
LK_L = Rint()
LK_R = Rint()
LK_I = Rint()
LK_T = C2D(ReadCH('FILE',1))
LK_ET = C2D(ReadCH('FILE',1))

LK_Q1 = C2D(ReadCH('FILE',1))
LK_Q2 = C2D(ReadCH('FILE',1))


say LKI TypeOf(LK_T) LK_I ': (' LK_P LK_C LK_L LK_R ')'  LK_ET LK_Q1 LK_Q2
Lenoff = LenOf(LK_T)
special = 0

if LenOff = 'xx' then leave

if LenOff = '??' then leave

/* sq checker.. */
if LK_T = KAN then do
an_TimB=readFlt()
an_TimE=readFlt()
an_Render=C2D(read2())
an_Width=C2d(Read2())
an_Height=C2d(Read2())
an_PixW=C2d(Read2())
an_PixH=C2d(Read2())

an_RPRF=C2d(Read2())
an_RPSF=C2d(Read2())
an_Bias=C2d(Read2())

an_Slice=C2d(Read2())
an_Flags=C2d(Read2())
an_AA=C2d(Read2())

say "Animation Times: Beg:" Veetime(An_TimB) " End:" Veetime(An_TimE)
say "Motion Blur: R/Frame:" An_RPRF " Frame denom:" AN_RPSF
say "Size: W:" AN_Width " H:" AN_HEight "aspect w/h" An_PixW "/" An_PixH
say "flags:" an_Flags " aa flags:" an_AA
Special = 1
end


/* sq checker.. */
if LK_T = KSQ then do
sq_T=readFlt()
Sq_Sex = 30.0 * Sq_t
sq_flag = C2D(READ2())
sq_opt = C2D(READ2())
say "SQ time(seq):" SQ_sex " : Flg:" SQ_Flag " repeats:" SQ_Opt
Special = 1
end


/* special section here for making the Styx file */


If LK_T = KKF then do
/* key frame... put down number of tweens?? */
KF_T=ReadFlt()
say " KF:" KF_T
/* writeln('LIST','/* ' || KF_T || ' Key frame ' || LK_I || ' */') */
Special=1
end




if LK_T = KVC then do
  VC_Beg = Rint(); VC_End = Rint()
  Say " VC:" VC_Beg VC_End
  special = 1
/*  writeln('LIST','VCb.'||LK_I '=' VC_Beg ' ; VCe.'||LK_I'='VC_End-1) */

 do i = VC_Beg to VC_End-1
/* for speed, use read4 instead of readflt */
if versC = 0 then do
  VT_S = ReadFlt()
  VT_X = ReadFlt()
  VT_Y = ReadFlt()
  VT_Z = Read4()
  VT_M = Read4()
  VT_R = Read4()
  end
else do
  VT_S = ReadFlt()
  VT_X = ReadFlt()
  VT_Y = ReadFlt()
  VT_Z = 0
  VT_M = Read4()
  VT_R = Vt_M
  end

if VT_S ~= 0 then oo_S =  trunc(VT_S,4)
  else  oo_S = 0

if VT_X ~= 0 then oo_X =  trunc(VT_X,3)
  else  oo_X = 0

if VT_y ~= 0 then oo_y =  trunc(VT_Y,3)
 else  oo_y = 0

/*  writeln('LIST','VTs.'||i '='OO_S';VTx.'||i '='OO_X'; VTy.'||i'='OO_Y) */

 end

end


if LK_T = KNV then do
  NV_Beg = Rint(); NV_End = Rint()
  Say " NV:" NV_Beg NV_End
  special = 1
/*  writeln('LIST','NVb.'||LK_I '=' NV_Beg ' ; NVe.'||LK_I'='NV_End-1) */

 do i = NV_Beg to NV_End-1


/* for speed, use read4 instead of readflt */
if versC = 0 then do
  VT_S = ReadFlt()
  VT_X = ReadFlt()
  VT_Y = ReadFlt()
  VT_Z = Read4()
  VT_M = Read4()
  VT_R = Read4()
  end
else do
  VT_S = ReadFlt()
  VT_X = ReadFlt()
  VT_Y = ReadFlt()
  VT_Z = 0
  VT_M = Read4()
  VT_R = Vt_M
  end

if VT_S ~= 0 then oo_S =  trunc(VT_S,4)
  else  oo_S = 0

if VT_X ~= 0 then oo_X =  trunc(VT_X,3)
  else  oo_X = 0

if VT_y ~= 0 then oo_y =  trunc(VT_Y,3)
 else  oo_y = 0

/*  writeln('LIST','VTs.'||i '='OO_S';VTx.'||i '='OO_X'; VTy.'||i'='OO_Y) */
 end

end

if LK_T = KMI then do
  MI_Beg = Rint(); MI_End = Rint()
  Say " MI:" MV_Beg MI_End
  special = 1

 dummy = READCH('FILE',(MI_End-MI_Beg)*24)

end

if LK_T = KIN then do
/*  writeln('LIST', "call NewLetter('X')" || lk_I ) */
end


if special = 0 then  dummy = readch('FILE',LenOff)

if EOF('FILE') = 1 then leave

end; /* do loop */

exit(0)



/* read a compressed byte into a number */
Rint:
Z=0
K=1
do forever

ch=C2D(readch('FILE',1))
if ch < 128 then do
	z=z+ch*k
 end
else do
	z=z+(ch-128)*k
 end
if  ch < 128  then leave;
k = k*128
end
 
return Z
/* will convert to ieee */
ReadFlt:
f = 0
Sgn = 1
pwr = 0
f=C2D(ReadCh('FILE',1))
f=f*256+C2D(ReadCh('FILE',1))
f=f*256+C2D(ReadCh('FILE',1))
pwr=C2d(ReadCh('FILE',1))

if pwr > 127 then do
 sgn = -1
 pwr = pwr-128
end
f = sgn*(2**(pwr-64-24))*f
return f

Read2:
return Readch('FILE',2)

Read4:
return Readch('FILE',4)

TypeOf:
Arg T
if T = 1 then return 'VT'
if T = 2 then return 'VC'
if T = 3 then return 'DS'
if T = 4 then return 'RV'
if T = 5 then return 'Rf'
if T = 6 then return 'MV'
if T = 7 then return 'RM'
if T = 8 then return 'NT'
if T = 9 then return 'NV'
if T = 10 then return 'MI'
if T = 11 then return 'SX'
if T = 12 then return 'VW'
if T = 13 then return 'LK'
if T = 14 then return 'IN'
if T = 15 then return 'AR'
if T = 16 then return 'VZ'
if T = 17 then return 'AN'
if T = 18 then return 'NX'
if T = 19 then return 'AP'
if T = 20 then return 'SQ'
if T = 21 then return 'KF'
if T = 22 then return 'PX'
if T = 23 then return 'CL'
if T = 24 then return 'PN'
if T = 25 then return 'XX'
if T = 26 then return 'FI'
Return '??'



LenOf:
Arg T
if T = 1 then return 24 /* 'VT' */
if T = 2 then return 8  /* 'VC' just beg-end points:bbx is on-the fly */
if T = 3 then return 10 /* 'DS' */
if T = 4 then return 'xx' /* 'RV' */
if T = 5 then return 'xx' /* 'Rf' */
if T = 6 then return 24 /* 'MV' */
if T = 7 then return 12 /* 'RM' */
if T = 8 then return 8  /* 'NT' */
if T = 9 then return 24 /* 'NV' */
if T = 10 then return 8  /* 'MI' */
if T = 11 then return 16 /* 'SX' */
if T = 12 then return 28 /* 'VW' */
if T = 13 then return 'xx' /* 'LK' */
if T = 14 then return   4 /* 'IN' */
if T = 15 then return 'xx' /* 'AR' */
if T = 16 then return 'xx' /* 'VZ' */
if T = 17 then return 30 /* 'AN' */
if T = 18 then return 72 /* 'NX' unused... */ 
if T = 19 then return 02 /* 'AP' */
if T = 20 then return 08 /* 'SQ' */
if T = 21 then return 04 /* 'KF' */
if T = 22 then return 12 /* 'PX' */
if T = 23 then return 8  /* 'CL' */
if T = 24 then return 4  /* 'PN' */
if T = 25 then return 'xx' /* 'XX' */
if T = 26 then return 'xx' /* 'FI' */
Return '??'



VeeTime:
Arg frames
z=""
fram=trunc(frames)
kh=30*60*60
km=kh/60
ks=km/60
hrs = fram%kh
fram=fram-kh*hrs
mins = fram%km
fram=fram-km*mins
secs = fram%ks
Frms= Fram-ks*secs
 z = hrs||":"||mins||":"||secs||"."||FRMS
return z
